{ SynthPLL modified from Synth
  12.02.07 C. Eberspaecher
}

CON
  _CLKMODE      = XTAL1 + PLL16X                        
  _XINFREQ      = 5_000_000
    
    MAINSFREQ =   50  ' Hz
    POFFSET   =   0
    FILTER    = 10 'shifts
    TSHIFT1    = 15 * 80_000_000/100/100   '13
    TSHIFT2    = 12 * 80_000_000/100/100   '10
        
    PLLOUT =      16 '25
    TRIGOUT =     3
    PLLIN   =     4 '4 20
    LED     =     27 
    
VAR
  long s, d, ctr, frq, frequ, stack[30], stack2[40] 
  long pdif, cntr, oldctr   
  long mainsin, oldmainsin,addit
  long posedge, oldposedge, on1, on2, off1, off2, pc, cycle, cyclem, status, oldstatus
  long time, looptime
  byte lockid
  

PUB StartPLL
  cycle:= CLKFREQ / MAINSFREQ
  pc:=0  

  lockid:= locknew
   
  cognew(PLL,@stack)
  cognew(TRIGGER,@stack2)     

PUB GetFRQ             'gives back mains frequency
  'result:= looptime
  result:=cyclem

PUB SetPC(PCSet)       ' Set Percentage for Dimmer
  if pcSet>95             ' Saturate
    pc:=100
  else    
    if pcSet<5
      pc:=0
    else
      pc:=pcSet
    
    
  off1:= cycle>>1 - TSHIFT1
  off2:= cycle   - TSHIFT2
   
  on1:= off1 - pc*cycle/200
  on2:= off2 - pc*cycle/200

  'off1:= on1+cycle/200/100
  'off2:= on2+cycle/200/100


PUB TRIGGER            ' Trigger to mains runs in own cog   working
  DIRA[PLLOUT]:=1 
  oldposedge:= cnt

  

  repeat
     
      waitcnt(cnt+CLKFREQ*10/510)                       'To prevent from early triggering

      repeat until(outa[PLLOUT]:=ina[PLLIN])            ' wait for positive edge
      outa[PLLOUT]:=0
        repeat until not lockset(lockid)
        time:= status:= 0   
        lockclr(lockid)
        
      cyclem := ((cnt-oldposedge)+cycle*15)/16    'average

      oldposedge:= cnt


PUB PLL                ' Phase output in single cog
  'dira[PLLOUT]~~
  dira[TRIGOUT]~~ 
  dira[LED]~~

  time:=status:=0
  oldctr:=cnt
  
  repeat

    cntr:= cnt
    repeat until not lockset(lockid)
    time+= (looptime:= cntr-oldctr)
    {if time>cycle
      'time:=time-cycle
      status:=0  
      time:=0}
    lockclr(lockid)  
      
    if time<on1 
      status:=0
      
    case status    
      0:
        if (time => on1)  and pc
          status:=1
      1:    
        if time => off1
          status:=2
      2: 
        if (time => on2) and pc
          status:=3
      3: 
        if time => off2
          status := 4
          
    if status<>oldstatus
      oldstatus:=status             
        if status&1
          outa[LED]:=1
          outa[TRIGOUT]:=1
        else
          outa[LED]:=0
          outa[TRIGOUT]:=0
           'outa:=0

    oldctr:=cntr
    'frequ:= cycle
    'frequ:= looptime
  

      

PUB Synth(CTR_AB, Pin, Freq)       ' Square wave at a pin with freq

  Freq := Freq #> 0 <# 128_000_000     'limit frequency range
  
  if Freq < 500_000                    'if 0 to 499_999 Hz,
    ctr := constant(%00100 << 26)      '..set NCO mode
    s := 1                             '..shift = 1
  else                                 'if 500_000 to 128_000_000 Hz,
    ctr := constant(%00010 << 26)      '..set PLL mode
    d := >|((Freq - 1) / 1_000_000)    'determine PLLDIV
    s := 4 - d                         'determine shift
    ctr |= d << 23                     'set PLLDIV
    
  frq := fraction(Freq, CLKFREQ, s)    'Compute FRQA/FRQB value
  ctr |= Pin                           'set PINA to complete CTRA/CTRB value

  if CTR_AB == "A"
     CTRA := ctr                        'set CTRA
     FRQA := frq                        'set FRQA                   
     DIRA[Pin]~~                        'make pin output
     
  if CTR_AB == "B"
     CTRB := ctr                        'set CTRB
     FRQB := frq                        'set FRQB                   
     DIRA[Pin]~~                        'make pin output

PRI fraction(a, b, shift) : f

  if shift > 0                         'if shift, pre-shift a or b left
    a <<= shift                        'to maintain significant bits while 
  if shift < 0                         'insuring proper result
    b <<= -shift
 
  repeat 32                            'perform long division of a/b
    f <<= 1
    if a => b
      a -= b
      f++           
    a <<= 1
    